<?php

namespace App\Classes\Modules\PerfexCRM\Services;

use App\Classes\Modules\PerfexCRM\DataTransferObjects\CustomerContactObject;
use Illuminate\Support\Facades\Http;
use App\Classes\Exceptions\MalformedRequestException;
use App\Classes\Exceptions\ConnectionErrorException;
use App\Classes\General\LogHelper;
use Illuminate\Support\Facades\Log;

class CreatesPerfexCRMCustomerContact
{
    /**
     * @param CustomerContactObject $customerContactObject
     * @return null|object
     * @throws MalformedRequestException
     */
    public function execute(CustomerContactObject $customerContactObject) {
        try{
            $data = [
                'customer_id' => $customerContactObject->getCustomerId(),
                'firstname' => $customerContactObject->getFirstName(),
                'lastname' => $customerContactObject->getLastName(),
                'email' => $customerContactObject->getEmail(), //$email
                'password' => $customerContactObject->getPassword(),
                'is_primary' => $customerContactObject->getIsPrimary(),
                //'send_set_password_email' => $customerContactObject->getSendSetPasswordEmail(),
            ];

            $response = Http::asForm()->withHeaders([
                'authtoken' => config('perfexcrm.api_key')])
            ->post(config('perfexcrm.base_url').'/api/contacts',$data);

            if($response->successful()){
                $data = $response->json();
                return (object) $data;
            }else{
                LogHelper::channel('perfex_crm')->info($response);
                return null;
            }
        }
        catch(\Illuminate\Http\Client\ConnectionException $exception){
            $error = 'Failed to connect to CRM';
            throw new ConnectionErrorException($error, $exception->getMessage(), "", $exception->getTraceAsString());
        }
        catch(\Exception $exception){
            throw new MalformedRequestException('Unable to get correct response from Perfex CRM server' . $exception->getMessage());
        }
    }
}
